【HDU1255】【线段树】【扫描线】【面积】

2024-08-31 16:38

本文主要是介绍【HDU1255】【线段树】【扫描线】【面积】,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

覆盖的面积

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 4417    Accepted Submission(s): 2180


Problem Description
给定平面上若干矩形,求出被这些矩形覆盖过至少两次的区域的面积.



Input
输入数据的第一行是一个正整数T(1<=T<=100),代表测试数据的数量.每个测试数据的第一行是一个正整数N(1<=N<=1000),代表矩形的数量,然后是N行数据,每一行包含四个浮点数,代表平面上的一个矩形的左上角坐标和右下角坐标,矩形的上下边和X轴平行,左右边和Y轴平行.坐标的范围从0到100000.

注意:本题的输入数据较多,推荐使用scanf读入数据.

Output
对于每组测试数据,请计算出被这些矩形覆盖过至少两次的区域的面积.结果保留两位小数.

Sample Input
  
2 5 1 1 4 2 1 3 3 7 2 1.5 5 4.5 3.5 1.25 7.5 4 6 3 10 7 3 0 0 1 1 1 0 2 1 2 0 3 1

Sample Output
  
7.63 0.00

Author
Ignatius.L & weigang Lee

Recommend
Ignatius.L




#include <iostream>
#include <cstring>
#include <cmath>
#include <queue>
#include <stack>
#include <list>
#include <map>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
using namespace std;#define rep(i,a,n) for (int i=a;i<n;i++)
#define per(i,a,n) for (int i=n-1;i>=a;i--)
#define mp push_back
#define lson l,m,rt<<1
#define rson m,r,rt<<1|1int T;
int n;
struct Edge
{double l,r,y;int f;Edge(){};Edge(double ll,double rr,double yy,int ff):l(ll),r(rr),y(yy),f(ff){};
}edge[1010*4];
int len;
double X[1010*4];
double sum[1010*10];
double more[1010*10];
int col[1010*10];
int cmp(Edge a,Edge b)
{return a.y < b.y;
}void PushUp(int rt,int l,int r)
{if(col[rt] >= 2){sum[rt] = more[rt] = X[r]- X[l];}else if(col[rt] == 1){sum[rt] = X[r] - X[l];if(r - l!=1)more[rt] = sum[rt<<1] + sum[rt<<1|1];elsemore[rt] = 0;}else{if(r - l == 1){sum[rt] = more[rt] = 0;}else{sum[rt] = sum[rt<<1] + sum[rt<<1|1];more[rt] = more[rt<<1] + more[rt<<1|1];}}
}void update(double L,double R,int c,int l,int r,int rt)
{if(L <= X[l] && X[r] <= R ){col[rt] += c;PushUp(rt,l,r);return;}int m = (l + r) >> 1;if(L < X[m]) update(L,min(R,X[m]),c,lson);if(X[m] < R) update(max(L,X[m]),R,c,rson);PushUp(rt,l,r);
}
int main()
{scanf("%d",&T);while(T --){len = 0;scanf("%d",&n);for(int i=0;i<n;i++){double x1,y1,x2,y2;scanf("%lf%lf%lf%lf",&x1,&y1,&x2,&y2);if(x1 > x2) swap(x1,x2);if(y1 > y2) swap(y1,y2);edge[len] = Edge(x1,x2,y1,1);X[len++] = x1;edge[len] = Edge(x1,x2,y2,-1);X[len++] = x2;}sort(edge,edge+len,cmp);sort(X,X+len);int MAXN = 1;for(int i=1;i<len;i++){if(X[i] != X[i-1]){X[MAXN++] = X[i]; }}//build(0,MAXN-1,1);memset(more,0,sizeof(more));memset(sum,0,sizeof(sum));memset(col,0,sizeof(col));double ans = 0;for(int i=0;i<len-1;i++){update(edge[i].l,edge[i].r,edge[i].f,0,MAXN-1,1);ans += more[1] * (edge[i+1].y - edge[i].y);}printf("%.2lf\n",ans);}}


这篇关于【HDU1255】【线段树】【扫描线】【面积】的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1124429

相关文章

poj3468(线段树成段更新模板题)

题意:包括两个操作:1、将[a.b]上的数字加上v;2、查询区间[a,b]上的和 下面的介绍是下解题思路: 首先介绍  lazy-tag思想:用一个变量记录每一个线段树节点的变化值,当这部分线段的一致性被破坏我们就将这个变化值传递给子区间,大大增加了线段树的效率。 比如现在需要对[a,b]区间值进行加c操作,那么就从根节点[1,n]开始调用update函数进行操作,如果刚好执行到一个子节点,

hdu1394(线段树点更新的应用)

题意:求一个序列经过一定的操作得到的序列的最小逆序数 这题会用到逆序数的一个性质,在0到n-1这些数字组成的乱序排列,将第一个数字A移到最后一位,得到的逆序数为res-a+(n-a-1) 知道上面的知识点后,可以用暴力来解 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#in

hdu1689(线段树成段更新)

两种操作:1、set区间[a,b]上数字为v;2、查询[ 1 , n ]上的sum 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<queue>#include<set>#include<map>#include<stdio.h>#include<stdl

hdu 1754 I Hate It(线段树,单点更新,区间最值)

题意是求一个线段中的最大数。 线段树的模板题,试用了一下交大的模板。效率有点略低。 代码: #include <stdio.h>#include <string.h>#define TREE_SIZE (1 << (20))//const int TREE_SIZE = 200000 + 10;int max(int a, int b){return a > b ? a :

hdu 1166 敌兵布阵(树状数组 or 线段树)

题意是求一个线段的和,在线段上可以进行加减的修改。 树状数组的模板题。 代码: #include <stdio.h>#include <string.h>const int maxn = 50000 + 1;int c[maxn];int n;int lowbit(int x){return x & -x;}void add(int x, int num){while

poj 1127 线段相交的判定

题意: 有n根木棍,每根的端点坐标分别是 px, py, qx, qy。 判断每对木棍是否相连,当他们之间有公共点时,就认为他们相连。 并且通过相连的木棍相连的木棍也是相连的。 解析: 线段相交的判定。 首先,模板中的线段相交是不判端点的,所以要加一个端点在直线上的判定; 然后,端点在直线上的判定这个函数是不判定两个端点是同一个端点的情况的,所以要加是否端点相等的判断。 最后

HDU4737线段树

题目大意:给定一系列数,F(i,j)表示对从ai到aj连续求或运算,(i<=j)求F(i,j)<=m的总数。 const int Max_N = 100008 ;int sum[Max_N<<2] , x[Max_N] ;int n , m ;void push_up(int t){sum[t] = sum[t<<1] | sum[t<<1|1] ;}void upd

zoj 1721 判断2条线段(完全)相交

给出起点,终点,与一些障碍线段。 求起点到终点的最短路。 枚举2点的距离,然后最短路。 2点可达条件:没有线段与这2点所构成的线段(完全)相交。 const double eps = 1e-8 ;double add(double x , double y){if(fabs(x+y) < eps*(fabs(x) + fabs(y))) return 0 ;return x + y ;

圆与线段的交点

poj 3819  给出一条线段的两个端点,再给出n个圆,求出这条线段被所有圆覆盖的部分占了整条线段的百分比。 圆与线段的交点 : 向量AB 的参数方程  P = A + t * (B - A)      0<=t<=1 ; 将点带入圆的方程即可。  注意: 有交点 0 <= t <= 1 ; 此题求覆盖的部分。 则 若求得 t  满足 ; double ask(d

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja